{Sergey Perevoznik}
{  TspDBRecNum 
        
   Delphi 1.0
       
 CurRecNumber,      run-time.
}

unit Spdbrec;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBiProcs, DBiTypes, StdCtrls, DBTables, Menus;


type

  TspDBRecNum = class(TComponent)
  private
    { Private declarations }
    FDataLink: TFieldDataLink;
    function  GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
    procedure DataChange(Sender: TObject);
    function  FindRecordNumber: longint;
    Function  CurrentRec : longInt;
    procedure UpdateRecStatus;
    procedure SetAbout(Value : string);
    function  GetAbout :string;
  protected
    { Protected declarations }
    CurRec : LongInt;
    cAbout : string;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    Property CurRecNumber : LongInt read CurrentRec;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property About     : string read GetAbout write SetAbout;
  end;

procedure Register;

implementation

{ construct the component }
constructor TspDBRecNum.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDataLink := TFieldDataLink.Create;
  FDataLink.OnDataChange   := DataChange; { attach method to event }
  FDataLink.OnActiveChange := DataChange; { attach method to event }
  Self.cAbout := '(c) Sergey Perevoznik, 1997';
end;

{ destroy the component }
destructor TspDBRecNum.Destroy;
begin
  FDataLink.Free;
  FDataLink := nil;
  inherited Destroy;
end;

{ method to get DataSource from DataLink }
function TspDBRecNum.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

{ method to set DataSource in DataLink }
procedure TspDBRecNum.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
end;

{ method to update the unpublished Caption property in
  response to a change in the DataSource }
procedure TspDBRecNum.DataChange(Sender: TObject);
begin
  if not (FDataLink.DataSource = nil) then UpdateRecStatus; { check DataSource NOT nil }
end;

{ method to find record number }
function TspDBRecNum.FindRecordNumber: Longint;
var
  cP: CurProps;
  rP: RECProps;
begin
  {Return 0 if dataset is not Paradox or dBase}
  Result := 0;

  with FDataLink.DataSource.Dataset do
  begin
    try
      {we need to make this call to grab the cursor's iSeqNums}
      Check(DBiGetCursorProps(Handle,cP));
      {synchronize the BDE cursor with the dataset's cursor}
      UpdateCursorPos;
      {fill rP with the current record's properties}
      Check(DBiGetRecord(Handle,DBiNOLOCK,nil,@rP));
      {what kind of dataset are we looking at?}
      case cP.iSeqNums of
        0: Result := rP.iPhyRecNum; {dBase}
        1: Result := rP.iSeqNum;    {Paradox}
      end;
    except
      Result := -1;
    end;
  end;
end;

procedure TspDBRecNum.UpdateRecStatus;
var
 i: longint;
begin
  with FDataLink.DataSource do
  {check if the database is active}
  if (DataSet <> nil) and (DataSet.State <> dsInActive) and (DataSet.RecordCount <> 0) then
  begin
    i := FindRecordNumber;
    if i >= 0 then
      Self.CurRec := i
    else I := 0;
  end else
  begin
    Self.CurRec := 0;
  end;
end;


Function TSpDBRecNum.CurrentRec : longint;
begin
  CurrentRec := CurRec;
end;

function TspDBRecNum.GetAbout: string;
begin
  Result := Self.cAbout;
end;

procedure TspDBRecNum.SetAbout(Value : string);
begin
  exit;
end;

procedure Register;
begin
  RegisterComponents('psv', [TspDBRecNum]);
end;

end.
